!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_hogbom
  use gbl_message
  !
  public :: hogbom_comm
  private
  !
contains
  !
  subroutine hogbom_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_def
    use clean_arrays
    !----------------------------------------------------------------------
    ! Implementation of Hogbom Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    ! Data checkup
    user_method%method = 'HOGBOM'
    call clean_data(error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(user_method)
    call copy_method(user_method,method)
    method%pflux = sic_present(1,0)
    method%pcycle = .false.
    method%qcycle = .false.
    call sub_clean(line,error)
  end subroutine hogbom_comm
end module clean_hogbom
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
