!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_multi
  use gbl_message
  !
  public :: multi_comm
  private
  !
contains
  !
  subroutine multi_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_def
    use clean_arrays
    !----------------------------------------------------------------------
    ! Implementation of Multi Scale Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    if (user_method%mosaic) then
       call map_message(seve%e,'MULTI','Not yet implemented for mosaic')
       error = .true.
       return
    endif
    !
    ! Data checkup
    user_method%method = 'MULTI'
    call clean_data (error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(user_method)
    call copy_method(user_method,method)
    method%pflux = sic_present(1,0)
    method%pcycle = .false.
    method%qcycle = .false.
    !
    method%gains = method%gain
    call sic_get_real('GAINS[1]',method%gains(1),error)
    call sic_get_real('GAINS[2]',method%gains(2),error)
    call sic_get_real('GAINS[3]',method%gains(3),error)
    !
    call sub_clean(line,error)
  end subroutine multi_comm
end module clean_multi
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
